// ConstantVolumeBarsDlg.cpp : implementation file
//

#include "stdafx.h"
#include <cassert>
#include "Common.h"
#include "Helper.h"
#include "ConstantVolumeBars.h"
#include "ConstantVolumeBarsDlg.h"
#include "ConstantVolumeBarsReqDlg.h"

const long CConstantVolumeBarsDlg::m_ShowCount = 5;
const long CConstantVolumeBarsDlg::m_MaxIdInterval = 500;

CConstantVolumeBarsDlg::CConstantVolumeBarsDlg(CWnd* pParent /*=NULL*/)
                           : CDialog(CConstantVolumeBarsDlg::IDD, pParent)
{
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CConstantVolumeBarsDlg::DoDataExchange(
                           CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_LBL_DATA_CONNECTION, m_lblDataConnection);

   DDX_Control(pDX, IDC_CMB_CONSTANT_VOLUME_BARS, m_cmbConstantVolumeBars);

   DDX_Control(pDX, IDC_BTN_REQUEST, m_btnRequest);
   DDX_Control(pDX, IDC_BTN_REMOVE, m_btnRemove);
   DDX_Control(pDX, IDC_BTN_REMOVE_ALL, m_btnRemoveAll);

   DDX_Control(pDX, IDC_LBL_STATUS, m_lblStatus);

   DDX_Text(pDX, IDC_LBL_SYMBOL, m_Symbol);
   DDX_Text(pDX, IDC_LBL_RANGE_START, m_RangeStart);
   DDX_Text(pDX, IDC_LBL_RANGE_END, m_RangeEnd);
   DDX_Text(pDX, IDC_LBL_UPDATES_ENABLED, m_UpdatesEnabled);
   DDX_Text(pDX, IDC_LBL_INCLUDE_END, m_IncludeEnd);
   DDX_Text(pDX, IDC_LBL_VOLUME_LEVEL, m_VolumeLevel);
   DDX_Text(pDX, IDC_LBL_VOLUME_TYPE, m_VolumeType);
   DDX_Text(pDX, IDC_LBL_INCLUDE_FLAT_TICKS, m_IncludeFlatTicks);
   DDX_Text(pDX, IDC_LBL_SESSIONS_FILTER, m_SessionsFilter);
   DDX_Text(pDX, IDC_LBL_CONTINUATION, m_Continuation);
   DDX_Text(pDX, IDC_LBL_EQUALIZE_CLOSES, m_EqualizeCloses);
   DDX_Text(pDX, IDC_LBL_DAYS_BEFORE_EXPIRATION, m_DaysBeforeExpiration);
   DDX_Text(pDX, IDC_LBL_SESSION_FLAGS, m_SessionFlags);
   DDX_Text(pDX, IDC_LBL_SUBSCRIPTION_LEVEL, m_SubscriptionLevel);
   DDX_Text(pDX, IDC_LBL_RECALC_PERIOD, m_RecalcPeriod);

   DDX_Text(pDX, IDC_LBL_OUTPUT_START, m_OutputStart);
   DDX_Text(pDX, IDC_LBL_OUTPUT_END, m_OutputEnd);

   DDX_Control(pDX, IDC_LBL_ERROR, m_lblError);

   DDX_Control(pDX, IDC_LSV_LAST_CONSTANT_VOLUME_BARS, m_lvLastConstantVolumeBars);
   DDX_Control(pDX, IDC_LSV_CONSTANT_VOLUME_BARS, m_lvConstantVolumeBars);

   DDX_Control(pDX, IDC_ED_TAG_NAME, m_edTagName);
   DDX_Control(pDX, IDC_ED_TAG_VALUE, m_edTagValue);

   DDX_Control(pDX, IDC_ED_FILTER_START_INDEX, m_edStart);
   DDX_Control(pDX, IDC_SPN_FILTER_START_INDEX, m_spnStart);
   DDX_Control(pDX, IDC_ED_FILTER_END_INDEX, m_edEnd);
   DDX_Control(pDX, IDC_SPN_FILTER_END_INDEX, m_spnEnd);

   DDX_Control(pDX, IDC_BTN_SHOW, m_btnShow);

   DDX_Control(pDX, IDC_LBL_RECS_COUNT, m_lblFltrRecsCount);
   DDX_Control(pDX, IDC_LBL_ALL_RECS_COUNT, m_lblAllRecsCount);
}

BEGIN_MESSAGE_MAP(CConstantVolumeBarsDlg, CDialog)
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_WM_DESTROY()
   ON_BN_CLICKED(IDC_BTN_REMOVE, OnBnClickedBtnRemove)
   ON_BN_CLICKED(IDC_BTN_REMOVE_ALL, OnBnClickedBtnRemoveAll)
   ON_BN_CLICKED(IDC_BTN_REQUEST, OnBnClickedBtnRequest)
   ON_BN_CLICKED(IDC_BTN_SHOW, OnBnClickedBtnShow)
   ON_CBN_SELCHANGE(IDC_CMB_CONSTANT_VOLUME_BARS, OnCbnSelChangeCmbConstantVolumeBars)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_START_INDEX, OnDeltaposSpnStart)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_END_INDEX, OnDeltaposSpnEnd)
END_MESSAGE_MAP()

BOOL CConstantVolumeBarsDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Set the icon for this dialog.  The framework does this automatically
   //  when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);       // Set big icon
   SetIcon(m_hIcon, FALSE);      // Set small icon

   try
   {
      InitializeControls();
      InitializeCQGCEL();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CConstantVolumeBarsDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

HCURSOR CConstantVolumeBarsDlg::OnQueryDragIcon()
{
   return static_cast<HCURSOR>(m_hIcon);
}

void CConstantVolumeBarsDlg::OnOK()
{
   // If enter clicked when one of the tag edit boxes is active
   // then call corresponding function
   CWnd* pWnd = GetFocus();

   if (pWnd == &m_edTagName)
   {
      OnEnterEdTagName();
   }
   else if (pWnd == &m_edTagValue)
   {
      OnEnterEdTagValue();
   }
}

void CConstantVolumeBarsDlg::OnDestroy()
{
   try
   {
      if (m_spCQGCEL)
      {
         HRESULT hr = ICQGCELDispEventImpl::DispEventUnadvise(m_spCQGCEL);
         assert(SUCCEEDED(hr));

         hr = m_spCQGCEL->Shutdown();
         Common::ThrowOnCOMError(m_spCQGCEL, hr);
      }
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   CDialog::OnDestroy();
}

void CConstantVolumeBarsDlg::OnBnClickedBtnRemove()
{
   try
   {
      // Remove selected constant volume bars from the collection
      HRESULT hr = m_spCQGCEL->RemoveConstantVolumeBars(m_spConstantVolumeBars);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      // Remove item from combo box
      int row = m_cmbConstantVolumeBars.GetCurSel();
      int count = m_cmbConstantVolumeBars.DeleteString(row);

      if (count == 0)
      {
         ClearAllData();
         m_spConstantVolumeBars = NULL;

         // Clear combo box
         m_cmbConstantVolumeBars.ResetContent();
      }
      else
      {
         m_cmbConstantVolumeBars.SetCurSel((row >= count ? (count - 1) : row));
         OnCbnSelChangeCmbConstantVolumeBars();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CConstantVolumeBarsDlg::OnBnClickedBtnRemoveAll()
{
   try
   {
      // Clear combo box
      m_cmbConstantVolumeBars.ResetContent();

      // Remove all constant volume bars from CQGCEL
      HRESULT hr = m_spCQGCEL->RemoveAllConstantVolumeBars();
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      m_spConstantVolumeBars = NULL;

      ClearAllData();

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CConstantVolumeBarsDlg::OnCbnSelChangeCmbConstantVolumeBars()
{
   try
   {
      ClearAllData();

      if (m_cmbConstantVolumeBars.GetCount() > 0)
      {
         // Get GUID from combo box
         CString id;
         m_cmbConstantVolumeBars.GetWindowText(id);

         // Get item from CQGCEL by GUID
         ATL::CComPtr<ICQGConstantVolumeBarsCollection> spAllConstantVolumeBars;
         HRESULT hr = m_spCQGCEL->get_AllConstantVolumeBars(&spAllConstantVolumeBars);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         m_spConstantVolumeBars.Release();
         hr = spAllConstantVolumeBars->get_ItemById(ATL::CT2W(id), &m_spConstantVolumeBars);
         Common::ThrowOnCOMError(spAllConstantVolumeBars, hr);

         // Show corresponding items all data
         ShowAllData();

         // Initialize parameters for filtering
         FillIndices();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CConstantVolumeBarsDlg::OnBnClickedBtnRequest()
{
   try
   {
      // Create empty request
      ATL::CComPtr<ICQGConstantVolumeBarsRequest> spRequest;
      HRESULT hr = m_spCQGCEL->CreateConstantVolumeBarsRequest(&spRequest);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      spRequest->put_SessionsFilter(ATL::CComVariant(31));  // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

      // Get line time from CQGCEL->Environment
      ATL::CComPtr<ICQGEnvironment> spEnvironment;
      hr = m_spCQGCEL->get_Environment(&spEnvironment);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      DATE lineTime;
      hr = spEnvironment->get_LineTime(&lineTime);
      Common::ThrowOnCOMError(spEnvironment, hr);

      // Open form to fill up request data
      CConstantVolumeBarsReqDlg dlg(spRequest, lineTime);
      if (dlg.DoModal() == IDOK)
      {
         // Send request to CQGCEL
         ATL::CComPtr<ICQGConstantVolumeBars> spConstantVolumeBars;
         hr = m_spCQGCEL->RequestConstantVolumeBars(spRequest, &spConstantVolumeBars);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         // Add ID to the requests combo box
         ATL::CComBSTR constantVolumeBarsID;
         hr = spConstantVolumeBars->get_Id(&constantVolumeBarsID);
         Common::ThrowOnCOMError(spConstantVolumeBars, hr);

         int row = m_cmbConstantVolumeBars.AddString(ATL::CW2T(constantVolumeBarsID));
         m_cmbConstantVolumeBars.SetCurSel(row);
         OnCbnSelChangeCmbConstantVolumeBars();
      }

      EnableControls();
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CConstantVolumeBarsDlg::OnBnClickedBtnShow()
{
   try
   {
      // Clear records and records count
      ClearRecords(m_lvConstantVolumeBars);
      m_lblFltrRecsCount.SetWindowText(_T(""));

      long startIndex;
      long endIndex;

      UpdateData();

      // Show filtered records and its' count when range is valid
      if (GetIndices(startIndex, endIndex))
      {
         m_lblFltrRecsCount.SetWindowText(GetValueAsString(endIndex - startIndex + 1));
         ShowRecords(startIndex, endIndex, m_lvConstantVolumeBars);
      }
   }
   catch (const std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

bool CConstantVolumeBarsDlg::GetIndices(
                           long& startIndex,
                           long& endIndex)
{
   startIndex = m_edStart.GetIntValue();
   endIndex = m_edEnd.GetIntValue();

   // Check for valid indices
   if (endIndex < startIndex)
   {
      AfxMessageBox(_T("Start index must be smaller than end index."), MB_ICONWARNING);
      return false;
   }

   if (startIndex < 1)
   {
      AfxMessageBox(_T("Start index must be greater than zero."), MB_ICONWARNING);
      return false;
   }

   long count;
   HRESULT hr = m_spConstantVolumeBars->get_Count(&count);
   Common::ThrowOnCOMError<ICQGConstantVolumeBars>(m_spConstantVolumeBars, hr);

   if (endIndex > count)
   {
      AfxMessageBox(_T("End index must be smaller than records count."), MB_ICONWARNING);
      return false;
   }

   if (endIndex - startIndex >= m_MaxIdInterval)
   {
      CString msgText;
      msgText.Format(_T("Range must indicate to no more than %d records."), m_MaxIdInterval);
      AfxMessageBox(msgText, MB_ICONWARNING);
      return false;
   }

   return true;
}

void CConstantVolumeBarsDlg::OnDeltaposSpnStart(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edStart.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CConstantVolumeBarsDlg::OnDeltaposSpnEnd(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edEnd.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CConstantVolumeBarsDlg::OnEnterEdTagName()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty()) 
      {
         return;
      }

      ATL::CComVariant tagValue;
      HRESULT hr = m_spConstantVolumeBars->get_Tag(ATL::CT2W(tagName), &tagValue);
      Common::ThrowOnCOMError(m_spConstantVolumeBars, hr);

      // If there is no tag with specified tag name, tag value will be VT_EMPTY
      m_edTagValue.SetWindowText((tagValue.vt != VT_EMPTY) ? GetValueAsString(tagValue) : _T(""));
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CConstantVolumeBarsDlg::OnEnterEdTagValue()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty())
      {
         return;
      }

      CString tagValue;
      m_edTagValue.GetWindowText(tagValue);

      // If there is no tag value specified, then remove tag with specified tag name
      HRESULT hr = m_spConstantVolumeBars->put_Tag(ATL::CT2W(tagName), 
         tagValue.IsEmpty() ? ATL::CComVariant() : ATL::CComVariant(tagValue));
      Common::ThrowOnCOMError(m_spConstantVolumeBars, hr);

      m_edTagName.SetWindowText(_T(""));
      m_edTagValue.SetWindowText(_T(""));

      m_edTagName.SetFocus();
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}